---
title: HTMLSelectElement.add()
slug: Web/API/HTMLSelectElement/add
tags:
  - API
  - HTML DOM
  - HTMLSelectElement
  - Method
  - Reference
---
<p>{{APIRef("HTML DOM")}}</p>

<p>The <code><strong>HTMLSelectElement.add()</strong></code> method adds an element to the collection of <code>option</code> elements for this <code>select</code> element.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>collection</var>.add(item[, before]);
</pre>

<h3 id="Parameters">Parameters</h3>

<ul>
 <li><em>item</em> is an {{domxref("HTMLOptionElement")}} or {{domxref("HTMLOptGroupElement")}}</li>
 <li><em>before</em> is optional and an element of the collection, or an index of type <em>long</em>, representing the <em>item</em> should be inserted before. If this parameter is <code>null</code> (or the index does not exist), the new element is appended to the end of the collection.</li>
</ul>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>A {{domxref("DOMError")}} of the type <code>HierarchyRequestError</code> if the <em>item </em>passed to the method is an ancestor of the <code>{{domxref("HTMLSelectElement")}}</code>.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_Elements_from_Scratch">Creating Elements from Scratch</h3>

<pre class="brush: js notranslate">var sel = document.createElement("select");
var opt1 = document.createElement("option");
var opt2 = document.createElement("option");

opt1.value = "1";
opt1.text = "Option: Value 1";

opt2.value = "2";
opt2.text = "Option: Value 2";

sel.add(opt1, null);
sel.add(opt2, null);

/*
  Produces the following, conceptually:

  &lt;select&gt;
    &lt;option value="1"&gt;Option: Value 1&lt;/option&gt;
    &lt;option value="2"&gt;Option: Value 2&lt;/option&gt;
  &lt;/select&gt;
*/</pre>

<p>The before parameter is optional. So the following is accepted.</p>

<pre class="brush: js notranslate">...
sel.add(opt1);
sel.add(opt2);
...
</pre>

<h3 id="Append_to_an_Existing_Collection">Append to an Existing Collection</h3>

<pre class="brush: js notranslate">var sel = document.getElementById("existingList");

var opt = document.createElement("option");
opt.value = "3";
opt.text = "Option: Value 3";

sel.add(opt, null);

/*
  Takes the existing following select object:

  &lt;select id="existingList"&gt;
    &lt;option value="1"&gt;Option: Value 1&lt;/option&gt;
    &lt;option value="2"&gt;Option: Value 2&lt;/option&gt;
  &lt;/select&gt;

  And changes it to:

  &lt;select id="existingList"&gt;
    &lt;option value="1"&gt;Option: Value 1&lt;/option&gt;
    &lt;option value="2"&gt;Option: Value 2&lt;/option&gt;
    &lt;option value="3"&gt;Option: Value 3&lt;/option&gt;
  &lt;/select&gt;
*/
</pre>

<p>The before parameter is optional. So the following is accepted.</p>

<pre class="brush:js notranslate">...
sel.add(opt);
...
</pre>

<h3 id="Inserting_to_an_Existing_Collection">Inserting to an Existing Collection</h3>

<pre class="brush: js notranslate">var sel = document.getElementById("existingList");

var opt = document.createElement("option");
opt.value = "3";
opt.text = "Option: Value 3";

sel.add(opt, sel.options[1]);

/*
  Takes the existing following select object:

  &lt;select id="existingList"&gt;
    &lt;option value="1"&gt;Option: Value 1&lt;/option&gt;
    &lt;option value="2"&gt;Option: Value 2&lt;/option&gt;
  &lt;/select&gt;

  And changes it to:

  &lt;select id="existingList"&gt;
    &lt;option value="1"&gt;Option: Value 1&lt;/option&gt;
    &lt;option value="3"&gt;Option: Value 3&lt;/option&gt;
    &lt;option value="2"&gt;Option: Value 2&lt;/option&gt;
  &lt;/select&gt;
*/
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#dom-select-add', 'HTMLSelectElement.add()')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'forms.html#dom-select-add', 'HTMLSelectElement.add()')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Is a snapshot of {{SpecName("HTML WHATWG")}}.<br>
    The value of <code>before</code> can now be a long and is optional. It throws a {{domxref("DOMError")}} of the type <code>HierarchyRequestError</code> if the passed <code>item</code> is an ancestor of the {{domxref("HTMLSelectElement")}} and no longer throws if the <code>before</code> parameter is not found.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 HTML', 'html.html#ID-14493106', 'HTMLSelectElement.add()')}}</td>
   <td>{{Spec2('DOM2 HTML')}}</td>
   <td>The method now throws an NOT_FOUND_ERR exception if the item of the <code>before</code> parameter is not a child of this element.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM1', 'level-one-html.html#ID-14493106', 'HTMLSelectElement.add()')}}</td>
   <td>{{Spec2('DOM1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.HTMLSelectElement.add")}}</p>
